diff --git a/src/bin/pg_combinebackup/t/004_manifest.pl b/src/bin/pg_combinebackup/t/004_manifest.pl
new file mode 100644
index 0000000000..37de61ac06
--- /dev/null
+++ b/src/bin/pg_combinebackup/t/004_manifest.pl
@@ -0,0 +1,75 @@
+# Copyright (c) 2021-2023, PostgreSQL Global Development Group
+#
+# This test aims to validate that pg_combinebackup works in the degenerate
+# case where it is invoked on a single full backup and that it can produce
+# a new, valid manifest when it does. Secondarily, it checks that
+# pg_combinebackup does not produce a manifest when run with --no-manifest.
+
+use strict;
+use warnings;
+use File::Compare;
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+# Set up a new database instance.
+my $node = PostgreSQL::Test::Cluster->new('node');
+$node->init(has_archiving => 1, allows_streaming => 1);
+$node->start;
+
+# Take a full backup.
+my $original_backup_path = $node->backup_dir . '/original';
+$node->command_ok(
+	[ 'pg_basebackup', '-D', $original_backup_path, '--no-sync', '-cfast' ],
+	"full backup");
+
+# Verify the full backup.
+$node->command_ok([ 'pg_verifybackup', $original_backup_path ],
+	"verify original backup");
+
+# Process the backup with pg_combinebackup using various manifest options.
+sub combine_and_test_one_backup
+{
+	my ($backup_name, $failure_pattern, @extra_options) = @_;
+	my $revised_backup_path = $node->backup_dir . '/' . $backup_name;
+	$node->command_ok(
+		[ 'pg_combinebackup', $original_backup_path, '-o', $revised_backup_path,
+				'--no-sync', @extra_options ],
+		"pg_combinebackup with @extra_options");
+	if (defined $failure_pattern)
+	{
+		$node->command_fails_like(
+			[ 'pg_verifybackup', $revised_backup_path ],
+			$failure_pattern,
+			"unable to verify backup $backup_name");
+	}
+	else
+	{
+		$node->command_ok(
+			[ 'pg_verifybackup', $revised_backup_path ],
+			"verify backup $backup_name");
+	}
+}
+combine_and_test_one_backup('nomanifest',
+	qr/could not open file.*backup_manifest/, '--no-manifest');
+combine_and_test_one_backup('csum_none',
+	undef, '--manifest-checksums=NONE');
+combine_and_test_one_backup('csum_sha224',
+	undef, '--manifest-checksums=SHA224');
+
+# Verify that SHA224 is mentioned in the SHA224 manifest lots of times.
+my $sha224_manifest =
+	slurp_file($node->backup_dir . '/csum_sha224/backup_manifest');
+my $sha224_count = (() = $sha224_manifest =~ /SHA224/mig);
+cmp_ok($sha224_count,
+	'>', 100, "SHA224 is mentioned many times in SHA224 manifest");
+
+# Verify that SHA224 is mentioned in the SHA224 manifest lots of times.
+my $nocsum_manifest =
+	slurp_file($node->backup_dir . '/csum_none/backup_manifest');
+my $nocsum_count = (() = $nocsum_manifest =~ /Checksum-Algorithm/mig);
+is($nocsum_count, 0,
+	"Checksum_Algorithm is not mentioned in no-checksum manifest");
+
+# OK, that's all.
+done_testing();
diff --git a/src/bin/pg_combinebackup/t/005_integrity.pl b/src/bin/pg_combinebackup/t/005_integrity.pl
new file mode 100644
index 0000000000..744adb759e
--- /dev/null
+++ b/src/bin/pg_combinebackup/t/005_integrity.pl
@@ -0,0 +1,123 @@
+# Copyright (c) 2021-2023, PostgreSQL Global Development Group
+#
+# This test aims to validate that an incremental backup can be combined
+# with a valid prior backup and that it cannot be combined with an invalid
+# prior backup.
+
+use strict;
+use warnings;
+use File::Compare;
+use File::Path qw(rmtree);
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+# Set up a new database instance.
+my $node1 = PostgreSQL::Test::Cluster->new('node1');
+$node1->init(has_archiving => 1, allows_streaming => 1);
+$node1->start;
+
+# Set up another new database instance. We don't want to use the cached
+# INITDB_TEMPLATE for this, because we want it to be a separate cluster
+# with a different system ID.
+my $node2;
+{
+	local $ENV{'INITDB_TEMPLATE'} = undef;
+
+	$node2 = PostgreSQL::Test::Cluster->new('node2');
+	$node2->init(has_archiving => 1, allows_streaming => 1);
+	$node2->start;
+}
+
+# Take a full backup from node1.
+my $backup1path = $node1->backup_dir . '/backup1';
+$node1->command_ok(
+	[ 'pg_basebackup', '-D', $backup1path, '--no-sync', '-cfast' ],
+	"full backup from node1");
+
+# Now take an incremental backup.
+my $backup2path = $node1->backup_dir . '/backup2';
+$node1->command_ok(
+	[ 'pg_basebackup', '-D', $backup2path, '--no-sync', '-cfast',
+	  '--incremental', $backup1path . '/backup_manifest' ],
+	"incremental backup from node1");
+
+# Now take another incremental backup.
+my $backup3path = $node1->backup_dir . '/backup3';
+$node1->command_ok(
+	[ 'pg_basebackup', '-D', $backup3path, '--no-sync', '-cfast',
+	  '--incremental', $backup2path . '/backup_manifest' ],
+	"another incremental backup from node1");
+
+# Take a full backup from node2.
+my $backupother1path = $node1->backup_dir . '/backupother1';
+$node2->command_ok(
+	[ 'pg_basebackup', '-D', $backupother1path, '--no-sync', '-cfast' ],
+	"full backup from node2");
+
+# Take an incremental backup from node2.
+my $backupother2path = $node1->backup_dir . '/backupother2';
+$node2->command_ok(
+	[ 'pg_basebackup', '-D', $backupother2path, '--no-sync', '-cfast',
+	  '--incremental', $backupother1path . '/backup_manifest' ],
+	"incremental backup from node2");
+
+# Result directory.
+my $resultpath = $node1->backup_dir . '/result';
+
+# Can't combine 2 full backups.
+$node1->command_fails_like(
+	[ 'pg_combinebackup', $backup1path, $backup1path, '-o', $resultpath ],
+	qr/is a full backup, but only the first backup should be a full backup/,
+	"can't combine full backups");
+
+# Can't combine 2 incremental backups.
+$node1->command_fails_like(
+	[ 'pg_combinebackup', $backup2path, $backup2path, '-o', $resultpath ],
+	qr/is an incremental backup, but the first backup should be a full backup/,
+	"can't combine full backups");
+
+# Can't combine full backup with an incremental backup from a different system.
+$node1->command_fails_like(
+	[ 'pg_combinebackup', $backup1path, $backupother2path, '-o', $resultpath ],
+	qr/expected system identifier.*but found/,
+	"can't combine backups from different nodes");
+
+# Can't omit a required backup.
+$node1->command_fails_like(
+	[ 'pg_combinebackup', $backup1path, $backup3path, '-o', $resultpath ],
+	qr/starts at LSN.*but expected/,
+	"can't omit a required backup");
+
+# Can't combine backups in the wrong order.
+$node1->command_fails_like(
+	[ 'pg_combinebackup', $backup1path, $backup3path, $backup2path, '-o', $resultpath ],
+	qr/starts at LSN.*but expected/,
+	"can't combine backups in the wrong order");
+
+# Can combine 3 backups that match up properly.
+$node1->command_ok(
+	[ 'pg_combinebackup', $backup1path, $backup2path, $backup3path, '-o', $resultpath ],
+	"can combine 3 matching backups");
+rmtree($resultpath);
+
+# Can combine full backup with first incremental.
+my $synthetic12path = $node1->backup_dir . '/synthetic12';
+$node1->command_ok(
+	[ 'pg_combinebackup', $backup1path, $backup2path, '-o', $synthetic12path ],
+	"can combine 2 matching backups");
+
+# Can combine result of previous step with second incremental.
+$node1->command_ok(
+	[ 'pg_combinebackup', $synthetic12path, $backup3path, '-o', $resultpath ],
+	"can combine synthetic backup with later incremental");
+rmtree($resultpath);
+
+# Can't combine result of 1+2 with 2.
+$node1->command_fails_like(
+	[ 'pg_combinebackup', $synthetic12path, $backup2path, '-o', $resultpath ],
+	qr/starts at LSN.*but expected/,
+	"can't combine synthetic backup with included incremental");
+
+# OK, that's all.
+done_testing();
diff --git a/src/bin/pg_combinebackup/write_manifest.c b/src/bin/pg_combinebackup/write_manifest.c
new file mode 100644
index 0000000000..82160134d8
--- /dev/null
+++ b/src/bin/pg_combinebackup/write_manifest.c
@@ -0,0 +1,293 @@
+/*-------------------------------------------------------------------------
+ *
+ * Write a new backup manifest.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/write_manifest.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres_fe.h"
+
+#include <fcntl.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "common/checksum_helper.h"
+#include "common/file_perm.h"
+#include "common/logging.h"
+#include "lib/stringinfo.h"
+#include "load_manifest.h"
+#include "mb/pg_wchar.h"
+#include "write_manifest.h"
+
+struct manifest_writer
+{
+	char		pathname[MAXPGPATH];
+	int			fd;
+	StringInfoData buf;
+	bool		first_file;
+	bool		still_checksumming;
+	pg_checksum_context manifest_ctx;
+};
+
+static void escape_json(StringInfo buf, const char *str);
+static void flush_manifest(manifest_writer *mwriter);
+static size_t hex_encode(const uint8 *src, size_t len, char *dst);
+
+/*
+ * Create a new backup manifest writer.
+ *
+ * The backup manifest will be written into a file named backup_manifest
+ * in the specified directory.
+ */
+manifest_writer *
+create_manifest_writer(char *directory)
+{
+	manifest_writer *mwriter = pg_malloc(sizeof(manifest_writer));
+
+	snprintf(mwriter->pathname, MAXPGPATH, "%s/backup_manifest", directory);
+	mwriter->fd = -1;
+	initStringInfo(&mwriter->buf);
+	mwriter->first_file = true;
+	mwriter->still_checksumming = true;
+	pg_checksum_init(&mwriter->manifest_ctx, CHECKSUM_TYPE_SHA256);
+
+	appendStringInfo(&mwriter->buf,
+					 "{ \"PostgreSQL-Backup-Manifest-Version\": 1,\n"
+					 "\"Files\": [");
+
+	return mwriter;
+}
+
+/*
+ * Add an entry for a file to a backup manifest.
+ *
+ * This is very similar to the backend's AddFileToBackupManifest, but
+ * various adjustments are required due to frontend/backend differences
+ * and other details.
+ */
+void
+add_file_to_manifest(manifest_writer *mwriter, const char *manifest_path,
+					 size_t size, pg_time_t mtime,
+					 pg_checksum_type checksum_type,
+					 int checksum_length,
+					 uint8 *checksum_payload)
+{
+	int			pathlen = strlen(manifest_path);
+
+	if (mwriter->first_file)
+	{
+		appendStringInfoChar(&mwriter->buf, '\n');
+		mwriter->first_file = false;
+	}
+	else
+		appendStringInfoString(&mwriter->buf, ",\n");
+
+	if (pg_encoding_verifymbstr(PG_UTF8, manifest_path, pathlen) == pathlen)
+	{
+		appendStringInfoString(&mwriter->buf, "{ \"Path\": ");
+		escape_json(&mwriter->buf, manifest_path);
+		appendStringInfoString(&mwriter->buf, ", ");
+	}
+	else
+	{
+		appendStringInfoString(&mwriter->buf, "{ \"Encoded-Path\": \"");
+		enlargeStringInfo(&mwriter->buf, 2 * pathlen);
+		mwriter->buf.len += hex_encode((const uint8 *) manifest_path, pathlen,
+									   &mwriter->buf.data[mwriter->buf.len]);
+		appendStringInfoString(&mwriter->buf, "\", ");
+	}
+
+	appendStringInfo(&mwriter->buf, "\"Size\": %zu, ", size);
+
+	appendStringInfoString(&mwriter->buf, "\"Last-Modified\": \"");
+	enlargeStringInfo(&mwriter->buf, 128);
+	mwriter->buf.len += strftime(&mwriter->buf.data[mwriter->buf.len], 128,
+								 "%Y-%m-%d %H:%M:%S %Z",
+								 gmtime(&mtime));
+	appendStringInfoChar(&mwriter->buf, '"');
+
+	if (mwriter->buf.len > 128 * 1024)
+		flush_manifest(mwriter);
+
+	if (checksum_length > 0)
+	{
+		appendStringInfo(&mwriter->buf,
+						 ", \"Checksum-Algorithm\": \"%s\", \"Checksum\": \"",
+						 pg_checksum_type_name(checksum_type));
+
+		enlargeStringInfo(&mwriter->buf, 2 * checksum_length);
+		mwriter->buf.len += hex_encode(checksum_payload, checksum_length,
+									   &mwriter->buf.data[mwriter->buf.len]);
+
+		appendStringInfoChar(&mwriter->buf, '"');
+	}
+
+	appendStringInfoString(&mwriter->buf, " }");
+
+	if (mwriter->buf.len > 128 * 1024)
+		flush_manifest(mwriter);
+}
+
+/*
+ * Finalize the backup_manifest.
+ */
+void
+finalize_manifest(manifest_writer *mwriter,
+				  manifest_wal_range *first_wal_range)
+{
+	uint8		checksumbuf[PG_SHA256_DIGEST_LENGTH];
+	int			len;
+	manifest_wal_range *wal_range;
+
+	/* Terminate the list of files. */
+	appendStringInfoString(&mwriter->buf, "\n],\n");
+
+	/* Start a list of LSN ranges. */
+	appendStringInfoString(&mwriter->buf, "\"WAL-Ranges\": [\n");
+
+	for (wal_range = first_wal_range; wal_range != NULL;
+		 wal_range = wal_range->next)
+		appendStringInfo(&mwriter->buf,
+						 "%s{ \"Timeline\": %u, \"Start-LSN\": \"%X/%X\", \"End-LSN\": \"%X/%X\" }",
+						 wal_range == first_wal_range ? "" : ",\n",
+						 wal_range->tli,
+						 LSN_FORMAT_ARGS(wal_range->start_lsn),
+						 LSN_FORMAT_ARGS(wal_range->end_lsn));
+
+	/* Terminate the list of WAL ranges. */
+	appendStringInfoString(&mwriter->buf, "\n],\n");
+
+	/* Flush accumulated data and update checksum calculation. */
+	flush_manifest(mwriter);
+
+	/* Checksum only includes data up to this point. */
+	mwriter->still_checksumming = false;
+
+	/* Compute and insert manifest checksum. */
+	appendStringInfoString(&mwriter->buf, "\"Manifest-Checksum\": \"");
+	enlargeStringInfo(&mwriter->buf, 2 * PG_SHA256_DIGEST_STRING_LENGTH);
+	len = pg_checksum_final(&mwriter->manifest_ctx, checksumbuf);
+	Assert(len == PG_SHA256_DIGEST_LENGTH);
+	mwriter->buf.len +=
+		hex_encode(checksumbuf, len, &mwriter->buf.data[mwriter->buf.len]);
+	appendStringInfoString(&mwriter->buf, "\"}\n");
+
+	/* Flush the last manifest checksum itself. */
+	flush_manifest(mwriter);
+
+	/* Close the file. */
+	if (close(mwriter->fd) != 0)
+		pg_fatal("could not close \"%s\": %m", mwriter->pathname);
+	mwriter->fd = -1;
+}
+
+/*
+ * Produce a JSON string literal, properly escaping characters in the text.
+ */
+static void
+escape_json(StringInfo buf, const char *str)
+{
+	const char *p;
+
+	appendStringInfoCharMacro(buf, '"');
+	for (p = str; *p; p++)
+	{
+		switch (*p)
+		{
+			case '\b':
+				appendStringInfoString(buf, "\\b");
+				break;
+			case '\f':
+				appendStringInfoString(buf, "\\f");
+				break;
+			case '\n':
+				appendStringInfoString(buf, "\\n");
+				break;
+			case '\r':
+				appendStringInfoString(buf, "\\r");
+				break;
+			case '\t':
+				appendStringInfoString(buf, "\\t");
+				break;
+			case '"':
+				appendStringInfoString(buf, "\\\"");
+				break;
+			case '\\':
+				appendStringInfoString(buf, "\\\\");
+				break;
+			default:
+				if ((unsigned char) *p < ' ')
+					appendStringInfo(buf, "\\u%04x", (int) *p);
+				else
+					appendStringInfoCharMacro(buf, *p);
+				break;
+		}
+	}
+	appendStringInfoCharMacro(buf, '"');
+}
+
+/*
+ * Flush whatever portion of the backup manifest we have generated and
+ * buffered in memory out to a file on disk.
+ *
+ * The first call to this function will create the file. After that, we
+ * keep it open and just append more data.
+ */
+static void
+flush_manifest(manifest_writer *mwriter)
+{
+	char		pathname[MAXPGPATH];
+
+	if (mwriter->fd == -1 &&
+		(mwriter->fd = open(mwriter->pathname,
+							O_WRONLY | O_CREAT | O_EXCL | PG_BINARY,
+							pg_file_create_mode)) < 0)
+		pg_fatal("could not open file \"%s\": %m", mwriter->pathname);
+
+	if (mwriter->buf.len > 0)
+	{
+		ssize_t		wb;
+
+		wb = write(mwriter->fd, mwriter->buf.data, mwriter->buf.len);
+		if (wb != mwriter->buf.len)
+		{
+			if (wb < 0)
+				pg_fatal("could not write \"%s\": %m", mwriter->pathname);
+			else
+				pg_fatal("could not write file \"%s\": wrote only %d of %d bytes",
+						 pathname, (int) wb, mwriter->buf.len);
+		}
+
+		if (mwriter->still_checksumming)
+			pg_checksum_update(&mwriter->manifest_ctx,
+							   (uint8 *) mwriter->buf.data,
+							   mwriter->buf.len);
+		resetStringInfo(&mwriter->buf);
+	}
+}
+
+/*
+ * Encode bytes using two hexademical digits for each one.
+ */
+static size_t
+hex_encode(const uint8 *src, size_t len, char *dst)
+{
+	const uint8 *end = src + len;
+
+	while (src < end)
+	{
+		unsigned	n1 = (*src >> 4) & 0xF;
+		unsigned	n2 = *src & 0xF;
+
+		*dst++ = n1 < 10 ? '0' + n1 : 'a' + n1 - 10;
+		*dst++ = n2 < 10 ? '0' + n2 : 'a' + n2 - 10;
+		++src;
+	}
+
+	return len * 2;
+}
diff --git a/src/bin/pg_combinebackup/write_manifest.h b/src/bin/pg_combinebackup/write_manifest.h
new file mode 100644
index 0000000000..8fd7fe02c8
--- /dev/null
+++ b/src/bin/pg_combinebackup/write_manifest.h
@@ -0,0 +1,33 @@
+/*-------------------------------------------------------------------------
+ *
+ * Write a new backup manifest.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/write_manifest.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef WRITE_MANIFEST_H
+#define WRITE_MANIFEST_H
+
+#include "common/checksum_helper.h"
+#include "pgtime.h"
+
+struct manifest_wal_range;
+
+struct manifest_writer;
+typedef struct manifest_writer manifest_writer;
+
+extern manifest_writer *create_manifest_writer(char *directory);
+extern void add_file_to_manifest(manifest_writer *mwriter,
+								 const char *manifest_path,
+								 size_t size, pg_time_t mtime,
+								 pg_checksum_type checksum_type,
+								 int checksum_length,
+								 uint8 *checksum_payload);
+extern void finalize_manifest(manifest_writer *mwriter,
+							  struct manifest_wal_range *first_wal_range);
+
+#endif							/* WRITE_MANIFEST_H */
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index 3ae3fc06df..5407f51a4e 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -85,6 +85,7 @@ static void RewriteControlFile(void);
 static void FindEndOfXLOG(void);
 static void KillExistingXLOG(void);
 static void KillExistingArchiveStatus(void);
+static void KillExistingWALSummaries(void);
 static void WriteEmptyXLOG(void);
 static void usage(void);
 
@@ -493,6 +494,7 @@ main(int argc, char *argv[])
 	RewriteControlFile();
 	KillExistingXLOG();
 	KillExistingArchiveStatus();
+	KillExistingWALSummaries();
 	WriteEmptyXLOG();
 
 	printf(_("Write-ahead log reset\n"));
@@ -1034,6 +1036,40 @@ KillExistingArchiveStatus(void)
 		pg_fatal("could not close directory \"%s\": %m", ARCHSTATDIR);
 }
 
+/*
+ * Remove existing WAL summary files
+ */
+static void
+KillExistingWALSummaries(void)
+{
+#define WALSUMMARYDIR XLOGDIR	"/summaries"
+#define WALSUMMARY_NHEXCHARS	40
+
+	DIR		   *xldir;
+	struct dirent *xlde;
+	char		path[MAXPGPATH + sizeof(WALSUMMARYDIR)];
+
+	xldir = opendir(WALSUMMARYDIR);
+	if (xldir == NULL)
+		pg_fatal("could not open directory \"%s\": %m", WALSUMMARYDIR);
+
+	while (errno = 0, (xlde = readdir(xldir)) != NULL)
+	{
+		if (strspn(xlde->d_name, "0123456789ABCDEF") == WALSUMMARY_NHEXCHARS &&
+			strcmp(xlde->d_name + WALSUMMARY_NHEXCHARS, ".summary") == 0)
+		{
+			snprintf(path, sizeof(path), "%s/%s", WALSUMMARYDIR, xlde->d_name);
+			if (unlink(path) < 0)
+				pg_fatal("could not delete file \"%s\": %m", path);
+		}
+	}
+
+	if (errno)
+		pg_fatal("could not read directory \"%s\": %m", WALSUMMARYDIR);
+
+	if (closedir(xldir))
+		pg_fatal("could not close directory \"%s\": %m", ARCHSTATDIR);
+}
 
 /*
  * Write an empty XLOG file, containing only the checkpoint record
diff --git a/src/include/access/xlogbackup.h b/src/include/access/xlogbackup.h
index 1611358137..90e04cad56 100644
--- a/src/include/access/xlogbackup.h
+++ b/src/include/access/xlogbackup.h
@@ -28,6 +28,8 @@ typedef struct BackupState
 	XLogRecPtr	checkpointloc;	/* last checkpoint location */
 	pg_time_t	starttime;		/* backup start time */
 	bool		started_in_recovery;	/* backup started in recovery? */
+	XLogRecPtr	istartpoint;	/* incremental based on backup at this LSN */
+	TimeLineID	istarttli;		/* incremental based on backup on this TLI */
 
 	/* Fields saved at the end of backup */
 	XLogRecPtr	stoppoint;		/* backup stop WAL location */
diff --git a/src/include/backup/basebackup.h b/src/include/backup/basebackup.h
index 1432d9c206..345bd22534 100644
--- a/src/include/backup/basebackup.h
+++ b/src/include/backup/basebackup.h
@@ -34,6 +34,9 @@ typedef struct
 	int64		size;			/* total size as sent; -1 if not known */
 } tablespaceinfo;
 
-extern void SendBaseBackup(BaseBackupCmd *cmd);
+struct IncrementalBackupInfo;
+
+extern void SendBaseBackup(BaseBackupCmd *cmd,
+						   struct IncrementalBackupInfo *ib);
 
 #endif							/* _BASEBACKUP_H */
diff --git a/src/include/backup/basebackup_incremental.h b/src/include/backup/basebackup_incremental.h
new file mode 100644
index 0000000000..c300235a2f
--- /dev/null
+++ b/src/include/backup/basebackup_incremental.h
@@ -0,0 +1,56 @@
+/*-------------------------------------------------------------------------
+ *
+ * basebackup_incremental.h
+ *	  API for incremental backup support
+ *
+ * Portions Copyright (c) 2010-2022, PostgreSQL Global Development Group
+ *
+ * src/include/backup/basebackup_incremental.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef BASEBACKUP_INCREMENTAL_H
+#define BASEBACKUP_INCREMENTAL_H
+
+#include "access/xlogbackup.h"
+#include "common/relpath.h"
+#include "storage/block.h"
+#include "utils/palloc.h"
+
+#define INCREMENTAL_MAGIC			0xd3ae1f0d
+
+typedef enum
+{
+	BACK_UP_FILE_FULLY,
+	BACK_UP_FILE_INCREMENTALLY,
+	DO_NOT_BACK_UP_FILE
+} FileBackupMethod;
+
+struct IncrementalBackupInfo;
+typedef struct IncrementalBackupInfo IncrementalBackupInfo;
+
+extern IncrementalBackupInfo *CreateIncrementalBackupInfo(MemoryContext);
+
+extern void AppendIncrementalManifestData(IncrementalBackupInfo *ib,
+										  const char *data,
+										  int len);
+extern void FinalizeIncrementalManifest(IncrementalBackupInfo *ib);
+
+extern void PrepareForIncrementalBackup(IncrementalBackupInfo *ib,
+										BackupState *backup_state);
+
+extern char *GetIncrementalFilePath(Oid dboid, Oid spcoid,
+									RelFileNumber relfilenumber,
+									ForkNumber forknum, unsigned segno);
+extern FileBackupMethod GetFileBackupMethod(IncrementalBackupInfo *ib,
+											char *path,
+											Oid dboid, Oid spcoid,
+											RelFileNumber relfilenumber,
+											ForkNumber forknum,
+											unsigned segno, size_t size,
+											unsigned *num_blocks_required,
+											BlockNumber *relative_block_numbers,
+											unsigned *truncation_block_length);
+extern size_t GetIncrementalFileSize(unsigned num_blocks_required);
+
+#endif
diff --git a/src/include/nodes/replnodes.h b/src/include/nodes/replnodes.h
index 4321ba8f86..856491eecd 100644
--- a/src/include/nodes/replnodes.h
+++ b/src/include/nodes/replnodes.h
@@ -108,4 +108,13 @@ typedef struct TimeLineHistoryCmd
 	TimeLineID	timeline;
 } TimeLineHistoryCmd;
 
+/* ----------------------
+ *		UPLOAD_MANIFEST command
+ * ----------------------
+ */
+typedef struct UploadManifestCmd
+{
+	NodeTag		type;
+} UploadManifestCmd;
+
 #endif							/* REPLNODES_H */
diff --git a/src/test/perl/PostgreSQL/Test/Cluster.pm b/src/test/perl/PostgreSQL/Test/Cluster.pm
index c3d46c7c70..b711d60fc4 100644
--- a/src/test/perl/PostgreSQL/Test/Cluster.pm
+++ b/src/test/perl/PostgreSQL/Test/Cluster.pm
@@ -779,6 +779,10 @@ a tar-format backup, pass the name of the tar program to use in the
 keyword parameter tar_program.  Note that tablespace tar files aren't
 handled here.
 
+To restore from an incremental backup, pass the parameter combine_with_prior
+as a reference to an array of prior backup names with which this backup
+is to be combined using pg_combinebackup.
+
 Streaming replication can be enabled on this node by passing the keyword
 parameter has_streaming => 1. This is disabled by default.
 
@@ -816,7 +820,22 @@ sub init_from_backup
 	mkdir $self->archive_dir;
 
 	my $data_path = $self->data_dir;
-	if (defined $params{tar_program})
+	if (defined $params{combine_with_prior})
+	{
+		my @prior_backups = @{$params{combine_with_prior}};
+		my @prior_backup_path;
+
+		for my $prior_backup_name (@prior_backups)
+		{
+			push @prior_backup_path,
+				$root_node->backup_dir . '/' . $prior_backup_name;
+		}
+
+		local %ENV = $self->_get_env();
+		PostgreSQL::Test::Utils::system_or_bail('pg_combinebackup',
+			@prior_backup_path, $backup_path, '-o', $data_path);
+	}
+	elsif (defined $params{tar_program})
 	{
 		mkdir($data_path);
 		PostgreSQL::Test::Utils::system_or_bail($params{tar_program}, 'xf',
diff --git a/src/test/recovery/t/001_stream_rep.pl b/src/test/recovery/t/001_stream_rep.pl
index 95f9b0d772..ad11be4664 100644
--- a/src/test/recovery/t/001_stream_rep.pl
+++ b/src/test/recovery/t/001_stream_rep.pl
@@ -15,6 +15,8 @@ my $node_primary = PostgreSQL::Test::Cluster->new('primary');
 $node_primary->init(
 	allows_streaming => 1,
 	auth_extra => [ '--create-role', 'repl_role' ]);
+# WAL summarization can postpone WAL recycling, leading to test failures
+$node_primary->append_conf('postgresql.conf', "wal_summarize_mb = 0");
 $node_primary->start;
 my $backup_name = 'my_backup';
 
diff --git a/src/test/recovery/t/019_replslot_limit.pl b/src/test/recovery/t/019_replslot_limit.pl
index 7d94f15778..4f52ddbe79 100644
--- a/src/test/recovery/t/019_replslot_limit.pl
+++ b/src/test/recovery/t/019_replslot_limit.pl
@@ -22,6 +22,7 @@ $node_primary->append_conf(
 min_wal_size = 2MB
 max_wal_size = 4MB
 log_checkpoints = yes
+wal_summarize_mb = 0
 ));
 $node_primary->start;
 $node_primary->safe_psql('postgres',
@@ -256,6 +257,7 @@ $node_primary2->append_conf(
 min_wal_size = 32MB
 max_wal_size = 32MB
 log_checkpoints = yes
+wal_summarize_mb = 0
 ));
 $node_primary2->start;
 $node_primary2->safe_psql('postgres',
@@ -310,6 +312,7 @@ $node_primary3->append_conf(
 	max_wal_size = 2MB
 	log_checkpoints = yes
 	max_slot_wal_keep_size = 1MB
+    wal_summarize_mb = 0
 	));
 $node_primary3->start;
 $node_primary3->safe_psql('postgres',
diff --git a/src/test/recovery/t/035_standby_logical_decoding.pl b/src/test/recovery/t/035_standby_logical_decoding.pl
index 9c34c0d36c..5fe4faf1be 100644
--- a/src/test/recovery/t/035_standby_logical_decoding.pl
+++ b/src/test/recovery/t/035_standby_logical_decoding.pl
@@ -250,6 +250,7 @@ $node_primary->append_conf(
 wal_level = 'logical'
 max_replication_slots = 4
 max_wal_senders = 4
+wal_summarize_mb = 0
 });
 $node_primary->dump_info;
 $node_primary->start;
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 7c913cbb93..064c0ecdc1 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -4004,3 +4004,15 @@ SummarizerReadLocalXLogPrivate
 WalSummarizerData
 WalSummaryFile
 WalSummaryIO
+FileBackupMethod
+IncrementalBackupInfo
+UploadManifestCmd
+backup_file_entry
+backup_wal_range
+cb_cleanup_dir
+cb_options
+cb_tablespace
+cb_tablespace_mapping
+manifest_data
+manifest_writer
+rfile
-- 
2.37.1 (Apple Git-137.1)

